/* $Id: tooltip.c,v 1.3 1999/03/05 13:28:46 bunka Exp $
 *
 *
 * Lab3Timer
 *
 * Copyright (C) 1999, Sebastian Bunka
 *
 * Distributed under the terms of the GNU GPL
 *
 *
 */

#include "forms.h"
#include "util.h"
#include "my_config.h"

static int timeoutID;



/* ###############################################################
	help tip routines
   ############################################################### */

static void do_tips(int id, void *p)
{
   FL_OBJECT *ob = p;

   fl_show_oneliner(ob->u_vdata, ob->form->x + ob->x,
                   ob->form->y + ob->y + ob->h + 1);
   timeoutID = fl_add_timeout(INTERVAL, do_tips, ob);
}

/*
 * use the post handler as a tipper
 */
int post_tip(FL_OBJECT *ob, int event,
            FL_Coord mx, FL_Coord my, int key, void *xev)
{
     if (no_tips == 1){			/* no tips requested ? */
	if (event == FL_LEAVE){		/* we need this action because a red blinking */
		fl_hide_oneliner();	/* timer field will show a tooltip with expiry time */
	}
       	return 0;
     }

     if(!ob->u_vdata)
       return 0;

     if(event == FL_ENTER)
         timeoutID = fl_add_timeout(INTERVAL,do_tips, ob);
     else if(event == FL_LEAVE || event == FL_PUSH)
     {
         fl_hide_oneliner();
         if(timeoutID)
         {
            fl_remove_timeout(timeoutID);
            timeoutID = 0;
         }
     }

     return 0;
}

void set_tip(FL_OBJECT *ob, char *s)
{
    ob->u_vdata = s;
    fl_set_object_posthandler(ob, post_tip);
}

